unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, ExtCtrls, Buttons, inifiles;


type

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    sb1: TStatusBar;
    ir1: TMenuItem;
    m: TMemo;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Info1: TMenuItem;
    N2: TMenuItem;
    posli1: TMenuItem;
    GetStatus1: TMenuItem;
    SetPort1: TMenuItem;
    Input01: TMenuItem;
    Input11: TMenuItem;
    Input21: TMenuItem;
    Input31: TMenuItem;
    N1: TMenuItem;
    RemoteControl1: TMenuItem;
    IRValueDetectEnable1: TMenuItem;
    IRValueDetectDisable1: TMenuItem;
    IRValueSet1: TMenuItem;
    N3: TMenuItem;
    Setting1: TMenuItem;
    Input41: TMenuItem;
    Input51: TMenuItem;
    Input61: TMenuItem;
    Input71: TMenuItem;
    Timer1: TTimer;
    IRValueGet1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Echo1Click(Sender: TObject);
    procedure GetStatus1Click(Sender: TObject);
    procedure Input01Click(Sender: TObject);
    procedure Input11Click(Sender: TObject);
    procedure Input21Click(Sender: TObject);
    procedure Input31Click(Sender: TObject);
    procedure Input41Click(Sender: TObject);
    procedure Input51Click(Sender: TObject);
    procedure Input61Click(Sender: TObject);
    procedure Input71Click(Sender: TObject);
    procedure Setting1Click(Sender: TObject);
    procedure IRValueDetectEnable1Click(Sender: TObject);
    procedure IRValueDetectDisable1Click(Sender: TObject);
    procedure IRValueSet1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure IRValueGet1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure AddStr(s:string);
   function openport: boolean;
   function doopenport(var ph: thandle; port: string): boolean;
   procedure SendCmd(cmd: string; chars: byte);
  end;

var

  Form1: TForm1;

implementation

uses unit2;

{$R *.DFM}

const rcvsize=1000;
type rcvbuf = array [0..rcvsize] of char;

const
       cmdlength = 3;
       echocmd = #0;
       infocmd = #1;
       getport = #2;
       setport = #3;
       irdetectenable = #4;
       irdetectdisable = #5;
       irsetvalue = #6;
       irgetvalue = #7;
       writeeprombyte = #9;
       getirvalues = #10;

var
  rcvtimeout: integer = 2;
  comhandle: thandle= 0;
  nrcv: cardinal;
  rcv: rcvbuf;
  portopen: boolean = false;
  enableidle: boolean = true;


procedure WDelay(delay: integer);
var n: tdatetime;
begin
 n := now+delay/(24*60*60*1000);
 while n > now do begin
  application.processmessages;
  sleepex(100,true);
 end;
end;

procedure ReadPort(var rstr: string; hex: boolean);
var i: integer;
    r: array [0..rcvsize] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
try
  if ClearCommError(comhandle,cst,@st) then begin
    sleepex(10,true);
    if st.cbInQue > 0 then begin
      if readfile(comhandle, r, sizeof(r)-1, nr, nil) then begin

       if nrcv + nr > rcvsize then begin
        nrcv := 0;
        if nr > rcvsize then exit; // discard chars
       end;

        move(r[0],rcv[nrcv],nr); nrcv := nrcv + nr;
        if nr <> 0 then begin
         for i := 0 to nr-1 do begin
            if r[i] = #13 then rstr := rstr + '<CR>' else
            if r[i] = #10 then rstr := rstr + '<LF>' else
            if not hex then begin
             if r[i] in [#32..#126] then rstr := rstr + r[i] else
              rstr := rstr + '0x'+inttohex(byte(r[i]),2)+' ';
            end else rstr := rstr + '0x'+inttohex(byte(r[i]),2)+' ';
         end;
        end;
      end;
    end;
  end;
except
 on e: exception do ebox(e.message);
end;
end;

function waitrcv(chars: byte; var rstr: string): boolean;
var t: tdatetime;
    timeout: boolean;
    cc: cardinal;
begin
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 t := now + rcvtimeout/(24*3600);
 cc := 0;
 repeat
  sleepex(100,true);
  if cc <> nrcv then begin
   t := now + rcvtimeout/(24*3600); cc := nrcv;
  end;
  timeout := t < now;
  application.ProcessMessages;
  ReadPort(rstr, false);
 until (nrcv >= chars) or timeout;
 if (nrcv < chars) or timeout then result := false else result := true;
end;

function TForm1.doopenport(var ph: thandle; port: string): boolean;
var dcb: tdcb;
    t:COMMTIMEOUTS;
begin
 result := false;
 ph := CreateFile(pchar(port),
    GENERIC_READ or GENERIC_WRITE, 0,nil, 
    OPEN_EXISTING, 0, 0);

 if ph = INVALID_HANDLE_VALUE then begin
  ebox('CreateFile INVALID_HANDLE_VALUE'#13+syserrormessage(GetLastError));
  exit;
 end;

 dcb.DCBlength := sizeof(dcb);
 if not GetCommState(ph, dcb) then
  begin
   ebox('ComHandle GetCommState '+syserrormessage(getlasterror));
   exit;
  end;

 dcb.BaudRate := 9600;
 dcb.Parity := 0;
 dcb.ByteSize := 8;
 dcb.StopBits := TWOSTOPBITS; //ONESTOPBIT;

 if not SetCommState(ph, dcb) then
  begin
   ebox('ComHandle SetCommState '+syserrormessage(getlasterror));
   exit;
  end;

 EscapeCommFunction(ph, SETDTR);
 EscapeCommFunction(ph, SETRTS);

 if not  getcommtimeouts(ph,t) then
  begin
   ebox('ComHandle GetCommTimeOuts '+syserrormessage(getlasterror));
   exit;
  end;

 t.ReadIntervalTimeout := 100;
 t.ReadTotalTimeoutMultiplier := 1;

 if not setcommtimeouts(ph, t) then
  begin
   ebox('ComHandle SetCommTimeOuts '+syserrormessage(getlasterror));
   exit;
  end;
 result := true;
end;

procedure ClearCom(h: thandle);
var r: array [0..1000] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 if ClearCommError(comhandle,cst,@st) and (st.cbInQue > 0) then begin
  readfile(h, r, sizeof(r)-1, nr, nil);
 end;
end;

function TForm1.openport: boolean;
var s: string;
    f: tinifile;
begin
 if comhandle <> 0 then if closehandle(comhandle) then comhandle := 0;
 result := false;

 f := tinifile.Create(_exedir+_exename+'.ini');
 s := f.ReadString('init','port','\\.\COM1');
 f.free;

 if not doopenport(comhandle,s) then exit;

 sleep(100);
 ClearCom(comhandle);
 result := true;
 portopen := true;
 addstr('Port opened');
end;


function SendString(s: string): boolean;
var wb: cardinal;
    l: integer;
begin
 result := false;
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 l := length(s);
 if not writefile(comhandle, s[1], l, wb, nil) then begin
  EBox(syserrormessage(getlasterror));
 end else result := true;
end;

procedure TForm1.AddStr(s:string);
begin
 m.lines.BeginUpdate;
try
// while m.lines.count > 100 do begin
//  m.Lines.Delete(m.lines.count-1);
// end;
 m.lines.insert(0,s);
finally
 m.lines.EndUpdate;
end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Ibox('IR Audio Switch        '#13#13'   version 1.0');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.SendCmd(cmd: string; chars: byte);
var p: string;
    i: integer;
begin
 sb1.Panels[1].text := '';
 if not portopen then openport;
 for i := length(cmd)+1 to cmdlength do cmd := cmd + #0;
 sb1.Panels[1].text := 'Sending data...';
 p := '';
 for i := 1 to length(cmd) do p := p + '0x'+inttohex(byte(cmd[i]),2)+' ';
 addstr('S: '+p);
 enableidle := false;
 if sendstring(cmd) then begin
  p := '';
  if waitrcv(chars, p) then begin
   addstr('R: '+p);
  end else begin
   if p <> '' then addstr('R: '+p);
   addstr('Receive error!');
   beep;
  end;
 end;
 enableidle := true;
 sb1.Panels[1].text := '';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 m.Clear;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 EscapeCommFunction(comhandle, CLRRTS);
 EscapeCommFunction(comhandle, CLRDTR);
 if comhandle <> 0 then closehandle(comhandle);
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 openport;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 if comhandle <> 0 then
 if closehandle(comhandle) then begin
  portopen := false;
  comhandle := 0;
 end;
 addstr('Port closed');
end;

const first:boolean = true;
procedure TForm1.FormActivate(Sender: TObject);
begin
 if first then begin
  first := false;
  openport;
 end;
end;

procedure TForm1.Echo1Click(Sender: TObject);
begin
 SendCmd(echocmd+#1#2,5);
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
 SendCmd(infocmd,2);
end;

procedure TForm1.GetStatus1Click(Sender: TObject);
begin
 SendCmd(getport,2);
end;

procedure TForm1.Input01Click(Sender: TObject);
begin
 SendCmd(setport+#0,2);
end;

procedure TForm1.Input11Click(Sender: TObject);
begin
 SendCmd(setport+#1,2);
end;

procedure TForm1.Input21Click(Sender: TObject);
begin
 SendCmd(setport+#2,2);
end;

procedure TForm1.Input31Click(Sender: TObject);
begin
 SendCmd(setport+#3,2);
end;

procedure TForm1.Input41Click(Sender: TObject);
begin
  SendCmd(setport+#4,2);
end;

procedure TForm1.Input51Click(Sender: TObject);
begin
 SendCmd(setport+#5,2);
end;

procedure TForm1.Input61Click(Sender: TObject);
begin
 SendCmd(setport+#6,2);
end;

procedure TForm1.Input71Click(Sender: TObject);
begin
 SendCmd(setport+#7,2);
end;

procedure TForm1.IRValueDetectEnable1Click(Sender: TObject);
begin
 SendCmd(irdetectenable,2);
end;

procedure TForm1.IRValueDetectDisable1Click(Sender: TObject);
begin
 SendCmd(irdetectdisable,2);
end;

procedure TForm1.IRValueSet1Click(Sender: TObject);
var s: string;
    p: byte;
begin
 if not InputQuery('Enter IR Value','',s) then exit;
 p := strtoint(trim(s));
 SendCmd(irsetvalue+char(p),3);
end;

procedure TForm1.IRValueGet1Click(Sender: TObject);
begin
 SendCmd(irgetvalue,3);
end;

procedure TForm1.Setting1Click(Sender: TObject);
var i: integer;
    e: boolean;
const datalen=maxir+2;
begin
 e := false;
 SendCmd(getirvalues,datalen);
 if nrcv = datalen then begin
  for i := 0 to maxir-1 do irdata[i] := byte(rcv[i]);
  form2.settings;
  if form2.ShowModal = mrok then begin
   for i := 0 to maxir-1 do begin
    SendCmd(writeeprombyte+chr(8+i)+chr(irdata[i]),2);
    if nrcv <> 2 then begin
     e := true;
     break;
    end;
   end;
   if e then ebox('Error on write!') else ibox('Done');
  end;
 end else ebox('Error on receive!');
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var p: string;
begin
 p := '';
 if enableidle then ReadPort(p, true);
 if p <> '' then addstr('R: '+p);
end;


end.


